<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'isAlive' => '\\StructType\\IsAlive',
            'isAliveResponse' => '\\StructType\\IsAliveResponse',
            'setAlive' => '\\StructType\\SetAlive',
            'setAliveResponse' => '\\StructType\\SetAliveResponse',
            'UserCredentials' => '\\StructType\\UserCredentials',
            'CreateShipment' => '\\StructType\\CreateShipment',
            'StdShipmentRequest' => '\\StructType\\StdShipmentRequest',
            'ShipmentRequestDefaultData' => '\\StructType\\ShipmentRequestDefaultData',
            'ShipmentRequestBase' => '\\StructType\\ShipmentRequestBase',
            'Address' => '\\StructType\\Address',
            'AddressMini' => '\\StructType\\AddressMini',
            'ShopAddress' => '\\StructType\\ShopAddress',
            'AddressInfo' => '\\StructType\\AddressInfo',
            'StdServices' => '\\StructType\\StdServices',
            'ServiceBaseList' => '\\StructType\\ServiceBaseList',
            'AppendOptionsBase' => '\\StructType\\AppendOptionsBase',
            'Bic3' => '\\StructType\\Bic3',
            'PickupData' => '\\StructType\\PickupData',
            'ServiceBase' => '\\StructType\\ServiceBase',
            'DefaultService' => '\\StructType\\DefaultService',
            'Consolidation' => '\\StructType\\Consolidation',
            'AutoConsolidation' => '\\StructType\\AutoConsolidation',
            'ReverseReturn' => '\\StructType\\ReverseReturn',
            'Parcel' => '\\StructType\\Parcel',
            'ReverseInverseReturn' => '\\StructType\\ReverseInverseReturn',
            'Reverse' => '\\StructType\\Reverse',
            'ParcelShop' => '\\StructType\\ParcelShop',
            'Contact' => '\\StructType\\Contact',
            'ExtraInsurance' => '\\StructType\\ExtraInsurance',
            'CreateShipmentResponse' => '\\StructType\\CreateShipmentResponse',
            'ArrayOfShipment' => '\\ArrayType\\ArrayOfShipment',
            'Shipment' => '\\StructType\\Shipment',
            'CreateShipmentWithLabels' => '\\StructType\\CreateShipmentWithLabels',
            'StdShipmentLabelRequest' => '\\StructType\\StdShipmentLabelRequest',
            'LabelType' => '\\StructType\\LabelType',
            'Bic3LabelData' => '\\StructType\\Bic3LabelData',
            'CreateShipmentWithLabelsResponse' => '\\StructType\\CreateShipmentWithLabelsResponse',
            'ShipmentsWithLabels' => '\\StructType\\ShipmentsWithLabels',
            'ArrayOfLabel' => '\\ArrayType\\ArrayOfLabel',
            'Label' => '\\StructType\\Label',
            'CreateMultiShipment' => '\\StructType\\CreateMultiShipment',
            'MultiShipmentRequest' => '\\StructType\\MultiShipmentRequest',
            'MultiServices' => '\\StructType\\MultiServices',
            'ArrayOfSlaveRequest' => '\\ArrayType\\ArrayOfSlaveRequest',
            'SlaveRequest' => '\\StructType\\SlaveRequest',
            'SlaveServices' => '\\StructType\\SlaveServices',
            'CreateMultiShipmentResponse' => '\\StructType\\CreateMultiShipmentResponse',
            'MultiShipment' => '\\StructType\\MultiShipment',
            'GetServiceNoticeAnswers' => '\\StructType\\GetServiceNoticeAnswers',
            'ServiceNoticeAnswersRequest' => '\\StructType\\ServiceNoticeAnswersRequest',
            'GetServiceNoticeAnswersResponse' => '\\StructType\\GetServiceNoticeAnswersResponse',
            'ServiceNoticeAnswersResponse' => '\\StructType\\ServiceNoticeAnswersResponse',
            'ArrayOfText' => '\\ArrayType\\ArrayOfText',
            'Text' => '\\StructType\\Text',
            'GetServiceNotices' => '\\StructType\\GetServiceNotices',
            'ServiceNoticeRequest' => '\\StructType\\ServiceNoticeRequest',
            'Customer' => '\\StructType\\Customer',
            'GetServiceNoticesResponse' => '\\StructType\\GetServiceNoticesResponse',
            'ServiceNoticeResponse' => '\\StructType\\ServiceNoticeResponse',
            'ArrayOfServiceNotice' => '\\ArrayType\\ArrayOfServiceNotice',
            'ServiceNotice' => '\\StructType\\ServiceNotice',
            'GetBic3' => '\\StructType\\GetBic3',
            'GetBic3Request' => '\\StructType\\GetBic3Request',
            'GetBic3Response' => '\\StructType\\GetBic3Response',
            'GetBic3Routing' => '\\StructType\\GetBic3Routing',
            'GetBic3RoutingRequest' => '\\StructType\\GetBic3RoutingRequest',
            'GeoRoutingRequest' => '\\StructType\\GeoRoutingRequest',
            'GeoRoutingBaseRequest' => '\\StructType\\GeoRoutingBaseRequest',
            'GetBic3RoutingResponse' => '\\StructType\\GetBic3RoutingResponse',
            'GeoRouting' => '\\StructType\\GeoRouting',
            'GetBic3DataRouting' => '\\StructType\\GetBic3DataRouting',
            'GetBic3DataRoutingRequest' => '\\StructType\\GetBic3DataRoutingRequest',
            'GeoRoutingDataRequest' => '\\StructType\\GeoRoutingDataRequest',
            'ArrayOfService' => '\\ArrayType\\ArrayOfService',
            'Service' => '\\StructType\\Service',
            'GetBic3DataRoutingResponse' => '\\StructType\\GetBic3DataRoutingResponse',
            'UpdateServiceNotice' => '\\StructType\\UpdateServiceNotice',
            'UpdateServiceNoticeRequest' => '\\StructType\\UpdateServiceNoticeRequest',
            'UpdateServiceNoticeResponse' => '\\StructType\\UpdateServiceNoticeResponse',
            'GetRetourShipmentData' => '\\StructType\\GetRetourShipmentData',
            'RetourShipmentRequest' => '\\StructType\\RetourShipmentRequest',
            'GetRetourShipmentDataResponse' => '\\StructType\\GetRetourShipmentDataResponse',
            'RetourShipmentData' => '\\StructType\\RetourShipmentData',
            'ShipmentData' => '\\StructType\\ShipmentData',
            'RetourServices' => '\\StructType\\RetourServices',
            'CreateReverseInverseShipment' => '\\StructType\\CreateReverseInverseShipment',
            'ReverseShipmentRequest' => '\\StructType\\ReverseShipmentRequest',
            'ReverseInverseServices' => '\\StructType\\ReverseInverseServices',
            'CreateReverseInverseShipmentResponse' => '\\StructType\\CreateReverseInverseShipmentResponse',
            'CreateReverseInverseShipmentWithLabels' => '\\StructType\\CreateReverseInverseShipmentWithLabels',
            'ReverseShipmentLabelRequest' => '\\StructType\\ReverseShipmentLabelRequest',
            'CreateReverseInverseShipmentWithLabelsResponse' => '\\StructType\\CreateReverseInverseShipmentWithLabelsResponse',
            'ShipmentWithLabels' => '\\StructType\\ShipmentWithLabels',
            'GetLabel' => '\\StructType\\GetLabel',
            'ReceiveLabelRequest' => '\\StructType\\ReceiveLabelRequest',
            'GetLabelResponse' => '\\StructType\\GetLabelResponse',
            'LabelResponse' => '\\StructType\\LabelResponse',
            'GetRetourLabel' => '\\StructType\\GetRetourLabel',
            'ReceiveRetourLabelRequest' => '\\StructType\\ReceiveRetourLabelRequest',
            'GetRetourLabelResponse' => '\\StructType\\GetRetourLabelResponse',
            'CreateCollectionRequest' => '\\StructType\\CreateCollectionRequest',
            'CollectionRequestRequest' => '\\StructType\\CollectionRequestRequest',
            'CollectionRequestServices' => '\\StructType\\CollectionRequestServices',
            'ContactCollectionRequest' => '\\StructType\\ContactCollectionRequest',
            'CreateCollectionRequestResponse' => '\\StructType\\CreateCollectionRequestResponse',
            'TerminateCollectionRequest' => '\\StructType\\TerminateCollectionRequest',
            'TerminateCollectionRequestRequest' => '\\StructType\\TerminateCollectionRequestRequest',
            'TerminateCollectionRequestResponse' => '\\StructType\\TerminateCollectionRequestResponse',
            'CreatePickupAtCustomer' => '\\StructType\\CreatePickupAtCustomer',
            'PickupAtCustomerRequest' => '\\StructType\\PickupAtCustomerRequest',
            'ArrayOfParcel' => '\\ArrayType\\ArrayOfParcel',
            'CreatePickupAtCustomerResponse' => '\\StructType\\CreatePickupAtCustomerResponse',
            'GetShipment' => '\\StructType\\GetShipment',
            'ShipmentRequest' => '\\StructType\\ShipmentRequest',
            'GetShipmentResponse' => '\\StructType\\GetShipmentResponse',
            'ShipmentDataExtended' => '\\StructType\\ShipmentDataExtended',
            'GetReverseOnDemandMode' => '\\StructType\\GetReverseOnDemandMode',
            'GetReverseOnDemandModeResponse' => '\\StructType\\GetReverseOnDemandModeResponse',
            'IsPickableOnDate' => '\\StructType\\IsPickableOnDate',
            'IsPickableRequest' => '\\StructType\\IsPickableRequest',
            'DayRequestBase' => '\\StructType\\DayRequestBase',
            'IsPickableOnDateResponse' => '\\StructType\\IsPickableOnDateResponse',
            'IsDeliverableOnDate' => '\\StructType\\IsDeliverableOnDate',
            'IsDeliverableRequest' => '\\StructType\\IsDeliverableRequest',
            'IsDeliverableOnDateResponse' => '\\StructType\\IsDeliverableOnDateResponse',
            'GetLastNumber' => '\\StructType\\GetLastNumber',
            'GetLastNumberRequest' => '\\StructType\\GetLastNumberRequest',
            'ArrayOfEntry' => '\\ArrayType\\ArrayOfEntry',
            'Entry' => '\\StructType\\Entry',
            'GetLastNumberResponse' => '\\StructType\\GetLastNumberResponse',
            'ArrayOfLong' => '\\ArrayType\\ArrayOfLong',
            'GetNationalTransitTime' => '\\StructType\\GetNationalTransitTime',
            'GetNationalTransitTimeRequest' => '\\StructType\\GetNationalTransitTimeRequest',
            'GetNationalTransitTimeResponse' => '\\StructType\\GetNationalTransitTimeResponse',
            'GetRdvShipmentData' => '\\StructType\\GetRdvShipmentData',
            'GetRdvShipmentDataRequest' => '\\StructType\\GetRdvShipmentDataRequest',
            'GetRdvShipmentDataResponse' => '\\StructType\\GetRdvShipmentDataResponse',
            'ArrayOfRdvShipmentData' => '\\ArrayType\\ArrayOfRdvShipmentData',
            'RdvShipmentData' => '\\StructType\\RdvShipmentData',
            'RdvAddress' => '\\StructType\\RdvAddress',
            'RdvDeliveryInfo' => '\\StructType\\RdvDeliveryInfo',
            'ArrayOfRdvService' => '\\ArrayType\\ArrayOfRdvService',
            'RdvService' => '\\StructType\\RdvService',
            'UpdateRdvShipmentDataForShop' => '\\StructType\\UpdateRdvShipmentDataForShop',
            'UpdateRdvShipmentDataForShopRequest' => '\\StructType\\UpdateRdvShipmentDataForShopRequest',
            'UpdateRdvShipmentData' => '\\StructType\\UpdateRdvShipmentData',
            'RdvEsnInfo' => '\\StructType\\RdvEsnInfo',
            'UpdateRdvShipmentDataForShopResponse' => '\\StructType\\UpdateRdvShipmentDataForShopResponse',
            'UpdateRdvShipmentDataForAgencyPickup' => '\\StructType\\UpdateRdvShipmentDataForAgencyPickup',
            'UpdateRdvShipmentDataForAgencyPickupRequest' => '\\StructType\\UpdateRdvShipmentDataForAgencyPickupRequest',
            'UpdateRdvShipmentDataForAgencyPickupResponse' => '\\StructType\\UpdateRdvShipmentDataForAgencyPickupResponse',
            'UpdateRdvShipmentDataForDeliveryToNewAddress' => '\\StructType\\UpdateRdvShipmentDataForDeliveryToNewAddress',
            'UpdateRdvShipmentDataNewDeliveryRequest' => '\\StructType\\UpdateRdvShipmentDataNewDeliveryRequest',
            'RdvData' => '\\StructType\\RdvData',
            'UpdateRdvShipmentDataForDeliveryToNewAddressResponse' => '\\StructType\\UpdateRdvShipmentDataForDeliveryToNewAddressResponse',
            'UpdateRdvShipmentDataForRedelivery' => '\\StructType\\UpdateRdvShipmentDataForRedelivery',
            'UpdateRdvShipmentDataForRedeliveryResponse' => '\\StructType\\UpdateRdvShipmentDataForRedeliveryResponse',
            'UpdateRdvShipmentDataForPredict' => '\\StructType\\UpdateRdvShipmentDataForPredict',
            'UpdateRdvShipmentDataPredictRequest' => '\\StructType\\UpdateRdvShipmentDataPredictRequest',
            'UpdateRdvShipmentDataForPredictResponse' => '\\StructType\\UpdateRdvShipmentDataForPredictResponse',
            'GetCustomerAddress' => '\\StructType\\GetCustomerAddress',
            'GetCustomerAddressResponse' => '\\StructType\\GetCustomerAddressResponse',
            'CustomerAddress' => '\\StructType\\CustomerAddress',
            'GetNumberRange' => '\\StructType\\GetNumberRange',
            'NumberRangeRequest' => '\\StructType\\NumberRangeRequest',
            'GetNumberRangeResponse' => '\\StructType\\GetNumberRangeResponse',
            'NumberRangeResponse' => '\\StructType\\NumberRangeResponse',
            'TerminateNumberRange' => '\\StructType\\TerminateNumberRange',
            'TerminateNumberRangeRequest' => '\\StructType\\TerminateNumberRangeRequest',
            'TerminateNumberRangeResponse' => '\\StructType\\TerminateNumberRangeResponse',
            'GetProperties' => '\\StructType\\GetProperties',
            'GetPropertiesRequest' => '\\StructType\\GetPropertiesRequest',
            'GetPropertiesResponse' => '\\StructType\\GetPropertiesResponse',
            'ArrayOfPropertyDefinition' => '\\ArrayType\\ArrayOfPropertyDefinition',
            'PropertyDefinition' => '\\StructType\\PropertyDefinition',
            'PutProperties' => '\\StructType\\PutProperties',
            'PutPropertiesRequest' => '\\StructType\\PutPropertiesRequest',
            'ArrayOfPropertyEntry' => '\\ArrayType\\ArrayOfPropertyEntry',
            'PropertyEntry' => '\\StructType\\PropertyEntry',
            'PutPropertiesResponse' => '\\StructType\\PutPropertiesResponse',
            'GetOptionValue' => '\\StructType\\GetOptionValue',
            'GetOptionRequest' => '\\StructType\\GetOptionRequest',
            'GetOptionValueResponse' => '\\StructType\\GetOptionValueResponse',
            'GetOptionResponse' => '\\StructType\\GetOptionResponse',
            'CheckIfReverseInverseShipmentExists' => '\\StructType\\CheckIfReverseInverseShipmentExists',
            'CheckIfReverseInverseShipmentExistsRequest' => '\\StructType\\CheckIfReverseInverseShipmentExistsRequest',
            'CheckIfReverseInverseShipmentExistsResponse' => '\\StructType\\CheckIfReverseInverseShipmentExistsResponse',
            'GetShipping' => '\\StructType\\GetShipping',
            'GetShippingRequest' => '\\StructType\\GetShippingRequest',
            'GetShippingResponse' => '\\StructType\\GetShippingResponse',
            'ArrayOfShipping' => '\\ArrayType\\ArrayOfShipping',
            'Shipping' => '\\StructType\\Shipping',
            'AddressName' => '\\StructType\\AddressName',
            'getInfo' => '\\StructType\\GetInfo',
            'getInfoResponse' => '\\StructType\\GetInfoResponse',
            'VerifyClient' => '\\StructType\\VerifyClient',
            'VerifyRequest' => '\\StructType\\VerifyRequest',
            'VerifyClientResponse' => '\\StructType\\VerifyClientResponse',
            'VerifyResponse' => '\\StructType\\VerifyResponse',
        );
    }
}
