<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RdvDeliveryInfo StructType
 * @subpackage Structs
 */
class RdvDeliveryInfo extends AbstractStructBase
{
    /**
     * The ContactName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ContactName;
    /**
     * The Digicode1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Digicode1;
    /**
     * The Digicode2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Digicode2;
    /**
     * The IntercomID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IntercomID;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The TimeFrom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TimeFrom;
    /**
     * The TimeTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TimeTo;
    /**
     * The Remark
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Remark;
    /**
     * Constructor method for RdvDeliveryInfo
     * @uses RdvDeliveryInfo::setContactName()
     * @uses RdvDeliveryInfo::setDigicode1()
     * @uses RdvDeliveryInfo::setDigicode2()
     * @uses RdvDeliveryInfo::setIntercomID()
     * @uses RdvDeliveryInfo::setDate()
     * @uses RdvDeliveryInfo::setTimeFrom()
     * @uses RdvDeliveryInfo::setTimeTo()
     * @uses RdvDeliveryInfo::setRemark()
     * @param string $contactName
     * @param string $digicode1
     * @param string $digicode2
     * @param string $intercomID
     * @param string $date
     * @param string $timeFrom
     * @param string $timeTo
     * @param string $remark
     */
    public function __construct($contactName = null, $digicode1 = null, $digicode2 = null, $intercomID = null, $date = null, $timeFrom = null, $timeTo = null, $remark = null)
    {
        $this
            ->setContactName($contactName)
            ->setDigicode1($digicode1)
            ->setDigicode2($digicode2)
            ->setIntercomID($intercomID)
            ->setDate($date)
            ->setTimeFrom($timeFrom)
            ->setTimeTo($timeTo)
            ->setRemark($remark);
    }
    /**
     * Get ContactName value
     * @return string|null
     */
    public function getContactName()
    {
        return $this->ContactName;
    }
    /**
     * Set ContactName value
     * @param string $contactName
     * @return \StructType\RdvDeliveryInfo
     */
    public function setContactName($contactName = null)
    {
        // validation for constraint: string
        if (!is_null($contactName) && !is_string($contactName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactName, true), gettype($contactName)), __LINE__);
        }
        $this->ContactName = $contactName;
        return $this;
    }
    /**
     * Get Digicode1 value
     * @return string|null
     */
    public function getDigicode1()
    {
        return $this->Digicode1;
    }
    /**
     * Set Digicode1 value
     * @param string $digicode1
     * @return \StructType\RdvDeliveryInfo
     */
    public function setDigicode1($digicode1 = null)
    {
        // validation for constraint: string
        if (!is_null($digicode1) && !is_string($digicode1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($digicode1, true), gettype($digicode1)), __LINE__);
        }
        $this->Digicode1 = $digicode1;
        return $this;
    }
    /**
     * Get Digicode2 value
     * @return string|null
     */
    public function getDigicode2()
    {
        return $this->Digicode2;
    }
    /**
     * Set Digicode2 value
     * @param string $digicode2
     * @return \StructType\RdvDeliveryInfo
     */
    public function setDigicode2($digicode2 = null)
    {
        // validation for constraint: string
        if (!is_null($digicode2) && !is_string($digicode2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($digicode2, true), gettype($digicode2)), __LINE__);
        }
        $this->Digicode2 = $digicode2;
        return $this;
    }
    /**
     * Get IntercomID value
     * @return string|null
     */
    public function getIntercomID()
    {
        return $this->IntercomID;
    }
    /**
     * Set IntercomID value
     * @param string $intercomID
     * @return \StructType\RdvDeliveryInfo
     */
    public function setIntercomID($intercomID = null)
    {
        // validation for constraint: string
        if (!is_null($intercomID) && !is_string($intercomID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($intercomID, true), gettype($intercomID)), __LINE__);
        }
        $this->IntercomID = $intercomID;
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \StructType\RdvDeliveryInfo
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get TimeFrom value
     * @return string|null
     */
    public function getTimeFrom()
    {
        return $this->TimeFrom;
    }
    /**
     * Set TimeFrom value
     * @param string $timeFrom
     * @return \StructType\RdvDeliveryInfo
     */
    public function setTimeFrom($timeFrom = null)
    {
        // validation for constraint: string
        if (!is_null($timeFrom) && !is_string($timeFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeFrom, true), gettype($timeFrom)), __LINE__);
        }
        $this->TimeFrom = $timeFrom;
        return $this;
    }
    /**
     * Get TimeTo value
     * @return string|null
     */
    public function getTimeTo()
    {
        return $this->TimeTo;
    }
    /**
     * Set TimeTo value
     * @param string $timeTo
     * @return \StructType\RdvDeliveryInfo
     */
    public function setTimeTo($timeTo = null)
    {
        // validation for constraint: string
        if (!is_null($timeTo) && !is_string($timeTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeTo, true), gettype($timeTo)), __LINE__);
        }
        $this->TimeTo = $timeTo;
        return $this;
    }
    /**
     * Get Remark value
     * @return string|null
     */
    public function getRemark()
    {
        return $this->Remark;
    }
    /**
     * Set Remark value
     * @param string $remark
     * @return \StructType\RdvDeliveryInfo
     */
    public function setRemark($remark = null)
    {
        // validation for constraint: string
        if (!is_null($remark) && !is_string($remark)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remark, true), gettype($remark)), __LINE__);
        }
        $this->Remark = $remark;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RdvDeliveryInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
